% LaTeX2HTML n'aime pas les input, donc on les enleve
% au passage, on enleve aussi les verbatiminput

flatten(FILE):-
	concat(FILE,'.tex',SRC),
	concat(FILE,'_complet.tex',DEST),
	file_content(SRC,TEXT),
	open(DEST,write,F),
	retractall(wf(_)),
	asserta((wf([]):-!)),
	assertz((wf([C|CONTENT]):-put(F,C),wf(CONTENT))),
	(	parse(TEXT,[])
	->	writef("\nOk\n")
	;	writef("\nErreur...\n")
	),
	close(F).

parse	--> "%", !, pCOMMENT(TEXT0), { wf([0'%|TEXT0]) }, parse.

parse	--> "\\input ", !, pNAME(NAME),
			{
				name(ATOM,NAME),
				concat(ATOM,'.tex',NAME_TEX),
				file_content(NAME_TEX,TEXT0),
				parse(TEXT0,[])
			},
			parse.

parse	-->	"\\endinput", !, parse.

parse	-->	"\\verbatiminput{", !, pID(NAME), "}",
			{
				name(ATOM,NAME),
				file_content(ATOM,TEXT0),
				wf("\\begin{verbatim}\n"),
				wf(TEXT0),
				wf("\\end{verbatim}\n")
			},
			parse.

parse	--> [C], !, { wf([C]) }, parse.

parse	--> [].

pCOMMENT([10])		--> [10], !.
pCOMMENT([C|TEXT])	-->	[C], !, pCOMMENT(TEXT).
pCOMMENT([])		--> [].

pNAME(NAME)	-->	pSEP, pID(NAME), pSEP.

pSEP	-->	([32]|[10]), !, pSEP.
pSEP	-->	[].

pID([C|NAME])	-->	[C], { C\=10, C\=32, C\=0'} }, pID(NAME).
pID([])			-->	[].

file_content(NAME,CONTENT):-
	writef("Input : %t\n",[NAME]),
	open(NAME,read,F),
	get0(F,C),
	scan(F,C,CONTENT),
	close(F).

scan(_,-1,[]):-!.
scan(F,C,[C|CONTENT]):-
	get0(F,C1),
	scan(F,C1,CONTENT).

